# پیکربندی HA Proxy
یک مهندس دواپس در نظر دارد برای وبسایتی که جدیدا در دست طراحی است پیکربندی مربوط به HAProxy را با توجه به نیازهایی که از سمت تیم دولوپمنت آمده است انجام دهد.

در معماری انجام شده، HAProxy به عنوان لودبالانسر/پراکسی، جلوی سرورهایی که برای وب سایت ایجاد شده اند قرار گرفته است در این پیاده سازی از چندین سرور(api application, nginx webserver) استفاده شده است و برای پاسخ به درخواست های وب سایت از این سرورها استفاده می شود.

در وبسایت مورد نظر یک اپلیکیشن با نام api که یک flask api است وظیفه جواب دادن به درخواست ها روی مسیر های `/games` ،  `/auth` و `/mobile` را دارد.

همچنین دو وب سرور Nginx وجود دارد که وظیفه جواب دادن به درخواست ها روی مسیر روت یا `/` را دارند که به صورت Fail Over یکدیگر کار می کنند.

## شرح سوال:

**الف:** در HAProxy، نیاز به پیکربندی داریم که بتوانیم با توجه به بالا بودن هر دو وب سرور nginx، برای مسیر روت یا `/`، ابتدا فقط ترافیک، به وب سرور با نام `app_primary` ارسال شود و در صورت از دسترس خارج شدن سرور اول ترافیک، به سمت وب سرور دوم با نام `app_secondary` ارسال گردد و زمانیکه مشکل وب سرور اول حل شد ترافیک مجدد فقط ب وب سرور `app_primary` ارسال شود.

**نکته:** تنظیمات haproxy باید به گونه ای باشد که همزمان ترافیک به هر دو وب سرور nginx **ارسال نگردد**.

**نکته:** وب سرورهای Nginx روی پورت 80 کار می کنند.

**نکته:** در تنظیمات HAProxy برای وب سرورهای Nginx یک backend با نام app تعریف شده است:

```
backend app
    http-response add-header x-Server %b/%s
    default-server check inter 1s fall 1 rise 3
```

**ب:** در پیکربندی HAProxy، مسیر های زیر باید توسط اپلیکیشن مورد نظر(api or nginx) جواب داده شود:

1. درخواست های به `/games` ، `/mobile` و `/auth` باید حتما توسط اپلیکیشن api جواب داده شود.

2. درخواست ها به مسیر روت باید توسط وب سرور Nginx جواب داده شود.

**ج:** تمامی درخواست هایی که توسط پلتفرم های همراه(موبایل، تبلت و ...) حتما بایستی به مسیر `/mobile` هدایت شوند. و در صورتی که درخواست مورد نظر از این پلتفرم ها نباشد بایستی به مسیر درخواستی خود هدایت شود.

**نکته:** در صورتی که درخواست مورد نظر از پلتفرم های همراه(موبایل، تبلت و ...) **نباشد** و مسیر مورد نظر در هیچ یک از backendها وجود **نداشته باشد** بایستی توسط Nginx پاسخ داده شود و به مسیر روت هدایت شود.

**نکته:** اپلیکیشن api روی پورت ۵۰۰۰ کار می کند.

**د:** در صورتی که درخواستی دارای کوئری (به عنوان مثال `/digikala?test`) باشد بایستی به مسیر روت هدایت شود.

**ه:** پیکربندی HAproxy باید به گونه ای باشد وقتی درخواستی با هدر `Auth: Basic SECURITY_KEY` به HAProxy رسید قسمت SECURITY_KEY از هدر درخواستی به صورت base64 در هدری با نام `auth-hash` به اپلیکیشن api داده شود.

**نکته:** اپلیکیشن api به این صورت کار می کند که اگر درخواستی با هدر `auth-hash` روی مسیر `/auth` برسد هدر مورد نظر را در خروجی چاپ می کند؛ در نظر داشته باشید که خروجی چاپ شده حتما بایستی مقدار base64 کلید مورد نظر در هدر Auth باشد.

**نکته:** درخواست های روی مسیر auth به صورت زیر ارسال می شود و دارای هدر Auth می باشند:

```
curl -H "Auth: Basic SECURITY_KEY" 127.0.0.1:8080/auth
```

به عنوان مثال برای کلید SECURITY_KEY باید مقدار زیر چاپ شود :

```
U0VDVVJJVFlfS0VZCg==
```

**نکته:** هیچ تغییری روی کد اپلیکیشن api **نباید** داده شود.

**نکته:** HAProxy در هیچ حالتی نباید خطای 5XX بدهد و برای هر مسیری(موجود و ناموجود) باید ریسپانس کد ۲۰۰ داشته باشد.

**نکته:** در تنظیمات HAProxy برای اپلیکیشن api که یک Flask api می باشد backend با نام api تعریف شده است.
```
backend api
    http-response add-header x-Server %b/%s
    default-server check inter 1s fall 1 rise 3
```

**نکته:** تعداد بکندهای تعریف شده در تنظیمات HAProxy نباید بیشتر از دو مورد موجود(api, app) باشد. 

**نکته:** برای ایجاد محیط تست از یک فایل docker-compose  استفاده شده است که پورت ۸۰۸۰ برای HAProxy پابلیش شده است که درخواست های به پورت ۸۰۸۰ هاست(سیستم شما)، به  HAProxy frontend روی پورت ۸۰ ارسال می شوند.
```
frontend http
    bind *:80
```

## شرایط تست

تنظیمات HA Proxy به شرح زیر می باشد( فایل ها را از لینک انتهای صفحه دریافت نمایید):
‍‍‍‍‍

```
# haproxy.cfg
global
    user root
    group root
    daemon
    stats timeout 30s

defaults
    log    global
    mode    http
    timeout connect 5000
    timeout client  50000
    timeout server  50000

frontend http
    bind *:80
    




backend api
    http-response add-header x-Server %b/%s
    default-server check inter 1s fall 1 rise 3



backend app
    http-response add-header x-Server %b/%s
    default-server check inter 1s fall 1 rise 3



```

**نکته:** در تعریف backendها در haproxy در نظر داشته باشید که اپلیکیشن api روی پورت ۵۰۰۰ کار می کند و وب سرورهای nginx روی پورت ۸۰ کار می کنند.

### دستورات مربوط به انجام تست
برای بالا آوردن محیط تست از دستور زیر استفاده کنید:

```
docker-compose up -d
```
برای از دسترس خارج کردن app وب سرور nginx می توانید از دستور زیر استفاده نمایید:

```
docker-compose stop app_primary
```
برای انجام تست دسترسی به مسیرهای مورد نظر از مرورگر خود آدرس `127.0.0.1:8080` را باز نمایید به عنوان مثال:

``` 
http://127.0.0.1:8080/
http://127.0.0.1:8080/mobile
http://127.0.0.1:8080/games
http://127.0.0.1:8080/auth
```
برای تست مسیر `/auth` میتوانید از دستور زیر استفاده کنید:

```
curl -H "Auth: Basic SECURITY_KEY" 127.0.0.1:8080/auth
```

## نحوه‌ی ارسال جواب

تغییرات خودتان را در محیط تست در فایل `haproxy.cfg`  اعمال کنید و سپس فایل خود را به **صورت زیپ شده** با نام دلخواه ارسال نمایید.( فایل های مورد نیاز را از لینک انتهای صفحه دریافت نمایید)

## دریافت فایل های محیط تست

فایل های مورد نیاز تست از طریق %problem.initial_project% قابل دسترسی می باشد.
